<?php // Global Front End Functions
start_session();
$_SESSION['aipath'] = $_SESSION['diagsDirectory'].'hpdiagsai';

   /***********************************************************************
   *    Copyright  2002 - 2006 Hewlett-Packard Development Company, L.P. *
   ***********************************************************************/

class client_info
{
	var $platform;
	var $browser;
	var $OsVersion;

	function client_info()
	{
	    // Get OS
	    if (strstr(PHP_OS, "Linux"))
	      $this->platform = "Linux";
	    else
	      $this->platform = "Windows";

		if ($this->platform == "Windows")
	  	{
			$verstring = exec("ver");

    	    if( ereg( '[0-9]+\.[0-9]+\.[0-9]+', $verstring, $matches))
    	    {
    	        $versions = split('\.', $matches[0]);

    	        $isWin2000 = 5==$versions[0] && 0==$versions[1];    # Win2K is 5.0.<build>

    	        if ($isWin2000)
					$this->OsVersion = "Win2K";
    	    }

	    }
	   		
		// Next, determine the browser they are using		
		if ( preg_match("/Opera ([0-9]\.[0-9]{0,2})/i", $this->get_user_agent(), $found) &&
			   strstr($this->get_user_agent(), "MSIE") )
		{
			// This will identify the Opera browser even when it tries to ID itself
			// as MSIE 5.0			
		 	$this->browser = "Opera " . $found[1];
		}
		else if ( preg_match("/Opera ([0-9]\.[0-9]{0,2})/i", $this->get_user_agent(), $found) &&
				 strstr($this->get_user_agent(), "Mozilla") )
		{
		  	// Finds Opera if ID's itself as Mozilla based browser
		 	$this->browser = "Opera " . $found[1];
		}
		else if ( preg_match("/Opera\/([0-9]\.[0-9]{0,2})/i", $this->get_user_agent(), $found) )
		{
		  // Finds Opera when ID'ing itself as Opera
		  $this->browser = "Opera " . $found[1];
		}
	    else if ( preg_match("/Netscape[0-9]\/([0-9]{1,2}\.[0-9]{1,2})/i", $this->get_user_agent(), $found) )
	    {
			 	// For Netscape 6.x
	    	$this->browser = "Netscape " . $found[1];
	    }
			else if ( preg_match("/Mozilla\/([0-9]{1}\.[0-9]{1,2}) \[en\]/i", $this->get_user_agent(),$found) )
	    {
			  // For Netscape 4.x
	    	$this->browser = "Netscape " . $found[1];
	    }		
	    else if ( preg_match("/MSIE ([0-9]{1,2})/i", $this->get_user_agent(), $found) )
	    {
				// For MSIE
	    	$this->browser = $found[0];
	    }    
		else
		  $this->browser = $this->get_user_agent();
	}
  
	// Return the platform detected
  function get_client_platform()
  {
  	return ($this->platform);
  }

	function IsWin2K()
	{			
	   	if ($this->get_OS_verString() == "Win2K")
	   		return true;
		else
			return false;
	}

	function get_OS_verString()
	{
		return ($this->OsVersion);
	}
  
  // Return the browser that we detected
  function get_client_browser()
	{
  	return ($this->browser);
  }
  
  // Return the user agent string
  function get_user_agent()
  {
  	return $_SERVER['HTTP_USER_AGENT'];
  }
  
}

/*************************************************
* This function validates diagconfig.xml.  You   *
* can pass it just a path to validate if the path*
* exists or you can pass it a path and a         *
* attribute to validate.                         *
*************************************************/
function checkDiagConfig($tag, $att="", $val="")
{
  $dom = LoadXmlDocument($_SESSION["diagsDirectory"]."diagconfig.xml");
  $diagConfig = xpath_new_context($dom->document_element());
  $obj = xpath_eval($diagConfig, $tag);
  if (count($obj->nodeset)) // did it find the tag?
  {
    if ($att == "") // if no atribute validation
      return true;
    else // validate attributes
    {
      $attribute = $obj->nodeset[0]->get_attribute($att);
      if ($attribute == $val) // does the attribute found equal the attribute to validate
        return true;
      else
        return false;
    }
  }
  else
    return false;
}

function IsFactory()
{
  return checkDiagConfig("/factory");
}

function IsPhoenix()
{
  return (getenv("PHOENIX") != NULL);
}

function IsDiagsCD()
{
  return ( getenv("HPDIAGS_CD") != NULL );
}

function IsOnline()
{
  return ( !IsPhoenix() && !IsDiagsCD());
}

function IsDiagnosable()
{
  $idXml = new DomDocument($_SESSION["idResult"]);
  $idXpath = @xpath_new_context($idXml->document_element());
  $devices = @xpath_eval($idXpath, "/diagOutput/category/device[@diagnosable='1']");
  if (count($devices->nodeset))
    return 1;
  else
    return 0;
}

/*******************************************************
* This function returns status in the form of MSG_XXXX
********************************************************/
function GetTestState($testStateIn)
{
 $testState="";
 
  // Some states are in the form 'running: Time out in 42 minutes'
  // Exploding the status will allow us to grab only the status, not the extra message
  $testStateInBits = explode(':',$testStateIn);
  switch ($testStateInBits[0])
  {
    case "completed": $testState = "MSG_COMPLETED";  break;
    case "canceled":  $testState = "MSG_CANCELED";   break;
    case "canceling": $testState = "MSG_CANCELING";  break;
    case "running":   $testState = "MSG_RUNNING";    break;
    case "busy":      $testState = "MSG_BUSY";       break;
    case "submitted": $testState = "MSG_SUBMITTED";  break;
    case "waiting":   $testState = "MSG_WAITING";    break;
    case "Passed":    $testState = "MSG_PASSED";     break;
    case "Failed":    $testState = "MSG_FAILED";     break;
    case "Fail":      $testState = "MSG_FAIL";       break;
    default: $testState = "MSG_IDLE";
  } 
    
 return $testState;
}


/********************************************
* This function will return a two character *
* formated language string retrieved from   *
* the browser                               *
********************************************/
function GetLanguage()
{
  $result = "en"; // default to English

  if (IsPhoenix() || IsDiagsCD())
  {
    $phoenixLanguageString = @file_get_contents("/root/compaq/language.txt");
    // we are only interested in the 1st three charcters
    if (strlen($phoenixLanguageString) > 3)
      $phoenixLanguageString = substr($phoenixLanguageString, 0, 3);
    switch ($phoenixLanguageString)
    {
      case "ENG": $result = "en"; break;
      case "FRE": $result = "fr"; break;
      case "ITA": $result = "it"; break;
      case "GER": $result = "de"; break;
      case "SPA": $result = "es"; break;
      case "JPN": $result = "ja"; break;
      default: $result = "en";
    }
  }

  else
  {
    $result = $_SERVER["HTTP_ACCEPT_LANGUAGE"];
    // we are only interested in the 1st two charcters
    if (strlen($result) > 2)
      $result = substr($result, 0, 2);
    else if (strlen($result) < 2)
      $result = "en"; // English is the default, in case there is not a 2-character code
  }

  // if it's not one of our supported languages, set it to English
  if ($result != "en" &&
      $result != "fr" &&
      $result != "it" &&
      $result != "de" &&
      $result != "es" &&
      $result != "ja")
    $result = "en";

  return $result;
}


/********************************************
* This function will  load an XML file into *
* a DomDocument without the localization    *
* character set problems we have observed   *
* when we try to use domxml_open_file       *
********************************************/
function LoadXmlDocument($filename)
{
  $fileContents = @file_get_contents($filename);
  $result = @new DomDocument($fileContents);
  return $result;
}


/********************************************
* This function builds a multi-deminsional  *
* array that contains the translations. The *
* first element of the array contains the   *
* English string and the second contains    *
* translated string.  It will load up the   *
* proper sdl.xx.xml translation file.  xx   *
* is the argument passed in - $slang        *
* Arg1: the language to translate into		*
********************************************/
function loadTransArray($slang)
{
  $translationArray = array();

  $sdlFile = $_SESSION["diagsDirectory"]. "sdl.".$slang.".xml";
  $commonFile = $_SESSION["diagsDirectory"]. "common.".$slang.".xml";

  // if language is English, we will load the English phrases
  // from the Spanish XML file, since we don't have an English-only XML file
  if ($slang == "en")
  {
    $sdlFile = $_SESSION["diagsDirectory"]. "sdl.es.xml";
    $commonFile = $_SESSION["diagsDirectory"]. "common.es.xml";
  }
 
  $real_pathnames[0] = realpath($sdlFile);
  $real_pathnames[1] = realpath($commonFile);

  foreach ($real_pathnames as $real_path)
  {
    if ($xmldoc = LoadXmlDocument($real_path)) // open correct sdl.xx.xml for translations
    {	// now populate the transArray with translations...
      $transXpath = xpath_new_context($xmldoc->document_element());
      $strings = xpath_eval($transXpath, "/string");
      $num_strings = count($strings->nodeset);
      for($i=0; $i < $num_strings; $i++)
      {
        $string = $strings->nodeset[$i];
        $id = $string->get_attribute("id");
        $keyXpath = xpath_new_context($string);
        $keys = xpath_eval($keyXpath, "/key");
        $num_keys = count($keys->nodeset);
        if ($num_keys)
        {  // better get here or the sdl.xx.xml file is missing a english key
          $key = $keys->nodeset[0];
          $englishKey = $key->get_content();
          // if the language is English, then the English phrase is all we need
          if ($slang == "en")
          {
            $translationArray[$id] = $englishKey;
          }
          else
          {
            $valueXpath = xpath_new_context($string);
            $values = xpath_eval($valueXpath, "/value");
            $num_values = count($values->nodeset);
            if ($num_values)
            { // hopefully gets here also.  this is the translated string
              $value = $values->nodeset[0];
              $transValue = $value->get_content();
              $translationArray[$id] = $transValue;
            }
            else
            {
              $translationArray[$id] = $englishKey;
            }
          }
        }
      }
    }
  }


  $_SESSION["transArray"] = $translationArray;
  return 1;  
}

/*******************************************
* This function will print the nice pretty *
* buttons that you see in the HTML         *
* Arg1: value of the button                *
* Arg2: the onClick event                  *
*******************************************/
function MakeButton($value, $onClick="", $id="")
{
  $buttonString = "";
  $buttonString = $buttonString . "<table border=0 cellspacing=0 cellpadding=0 onclick=\"" . $onClick . "\"><tr>";
  $buttonString = $buttonString . "  <td class=\"button_top_left\"></td>";
  $buttonString = $buttonString . "  <td class=\"button_top\"></td>";
  $buttonString = $buttonString . "    <td class=\"button_top_right\"></td>";
  $buttonString = $buttonString . "  </tr>  <tr>";
  $buttonString = $buttonString . "    <td class=\"button_left\"></td>";
  $buttonString = $buttonString . "    <td class=\"button_middle\"><a href=# class=\"button\" id=\"". $id . "\">"  . $value . "</a></td>";
  $buttonString = $buttonString . "    <td class=\"button_right\"></td>";
  $buttonString = $buttonString . "  </tr><tr>";
  $buttonString = $buttonString . "    <td class=\"button_bottom_left\"></td>";
  $buttonString = $buttonString . "    <td class=\"button_bottom\"></td>";
  $buttonString = $buttonString . "    <td class=\"button_bottom_right\"></td>";
  $buttonString = $buttonString . "  </tr></table>";
  
  return $buttonString;  
}


/*******************************************
* This function gets the browsers language *
* setting and then loads up the proper     *
* translated strings into a mulit-dimen    *
* array with the English string being the  *
* first element
*******************************************/
function TR($translateMe)
{
  $result = $translateMe; // default to english string passed in
  if (isset($_SESSION["transArray"][$translateMe]))
  {
    $result = $_SESSION["transArray"][$translateMe];
  }
  return $result;
}


function SurveyOnly()
{
  $dom = LoadXmlDocument($_SESSION["diagsDirectory"]."diagconfig.xml");
  $diagConfig = xpath_new_context($dom->document_element());
  $mode = xpath_eval($diagConfig, "/mode");
  if (count($mode->nodeset))
  {
    $surveyOnly = $mode->nodeset[0]->get_attribute("surveyOnly");    
    if ($surveyOnly == "1")
    {
      $envior = $mode->nodeset[0]->get_attribute("envior");
      if ($envior == "online" && IsOnline())
        return true;
      else if ($envior == "smartstart" && IsPhoenix())
        return true;
      else
        return false;  
    }
    else
     return false;
  }
  else
    return false;
}

// Parses a string that was from the crontab into an array
function ParseCronField($field, $minVal, $maxVal)
{
  $result = FALSE;

  if (!($minVal < $maxVal))
    return $result;

  // fill the array to FALSE
  $result = array_fill($minVal, $maxVal+1, FALSE);

  // first we'll get all the ranges (delimited by commas)
  $tokens = split("[, \t]", $field);
  if ($tokens) foreach($tokens as $rangeToken)
  {    // see if there's a '/<number>' specified with this range (meaning to skip by that number)
    $skipBy = 1;
    $slashpos = strrpos($rangeToken, '/');
    if ($slashpos)
    {
      $skipByStr = substr($rangeToken, $slashpos + 1);
      if (is_numeric($skipByStr))
        $skipBy = max(1, intval($skipByStr));
      $rangeToken = substr($rangeToken, 0, $slashpos);
    }

    $rangeFirst = 0;
    $rangeSecond = 0;

    // an asterisk('*') always means minVal - maxVal
    if ($rangeToken == "*")
    {
      $rangeFirst = $minVal;
      $rangeSecond = $maxVal;
    }
    // otherwise range token should begin with digit
    else if (is_numeric($rangeToken[0]))
    {
      $dashpos = strpos($rangeToken, '-');
      if ($dashpos)
      {
        $rangeFirst = intval(substr($rangeToken, 0, $dashpos));
        $rangeSecond = intval(substr($rangeToken, $dashpos + 1));
      }
      else
      {
        $rangeFirst = intval($rangeToken);
        $rangeSecond = $rangeFirst;
      }
    }

    // loop from $rangeFirst through $rangeSecond
    for ($i = $rangeFirst; $i <= $rangeSecond; $i += $skipBy)
    {
      if ($i >= $minVal && $i <= $maxVal)
        $result[$i] = TRUE;;
    }
  }

  return $result;
}

/********************************************************
* This function will replace a string (ToReplaceText))  *
* that resides inside another string (rStr) with a new  *
* string (ReplaceText) and return the modified string   *
********************************************************/
function ReplaceString($rStr,$ToReplaceText,$ReplaceText) 
{
	$rTempStr=explode($ToReplaceText,$rStr);
	$rStr=implode($ReplaceText,$rTempStr);
	return $rStr;
}

// remove string from a string
function StripString($rStr,$StripText) 
{
	$rTempStr=explode($StripText,$rStr);
	$rStr=implode("",$rTempStr);
	return $rStr;
}

/**************************************************************
* Outputs XML content to an HTML table as a String, to be used*
* for Saving, not for Display                                 *
**************************************************************/
function outputTableContent(&$oss, $obj, $depth, &$alt)
{
  $caption = $obj->get_attribute('caption');
  $value = $obj->get_attribute('value');
  $description = $obj->get_attribute('description');
  $testOnly = $obj->get_attribute('testOnly');
  $techDetail = $obj->get_attribute('techDetail');
  $hexData = $obj->get_attribute('hexData');

  if ($depth == 0 || $hexData == '1' || ($value == '' && $description == ''))
    $colspan = "2";
  else
    $colspan = "1";
  
  if ($testOnly == '1' || ($_SESSION['surveyLevel'] == 'Summary' && ($techDetail == '1' || $hexData == '1')))
    return;   //Do not print out - do nada - skip the entire process

  if ($depth == 0) // if heading
  {
    if ($caption == '')
      $caption = TR('MSG_UNDEFINED');
    $tag = 'th';
    $alt = false;
  }
  else if ($depth == 1) // if sub heading
  {
    if ($caption == '')
      $caption = TR('MSG_UNDEFINED');
    $tag = 'td';
    $alt = !($alt);
  }
  else
  {
    $tag = 'td';
    $alt = !($alt);
  }
  
  $class = '';
  if ($alt == true)
    $class = 'class="alt" ';

  $span = '';
  if ($colspan == "2")
    $span = 'colspan="2" ';

  $padding = '';
  if ($depth > 1)
    $padding = 'style="padding-left: '.(20 * ($depth - 1)).'px" ';

  $oss .= '<tr '.$class.'>'."\n".'<'.$tag.' '.$span.$padding.'>'.$caption;
  
  if ($colspan == "2")
  {
    if ($value != '')
      $oss .= ' - '.$value;
    else if ($description != '' && $description != $caption)
      $oss .= ' - '.$description;
    $oss .= '</'.$tag.'>'."\n";
  }
  else
  {
    $oss .= '</'.$tag.'>'."\n".'<'.$tag.'>';
    if ($value != '')
      $oss .= $value;
    else if ($description != '' && $description != $caption)
      $oss .= $description;
    $oss .= '</'.$tag.'>'."\n";
  }
  $oss .= '</tr>'."\n";

  // Iterate through nested objects and call this function recursively.
  $nestedObjects = $obj->child_nodes();
  foreach ($nestedObjects as $nestedObj)
  {
    if (isset($nestedObj->tagname))
      $tagname = $nestedObj->tagname;
    else
      $tagname = '';
    if ($tagname == 'device' || $tagname == 'structure' || $tagname == 'property')
    {
      $depth++;
      //outputTableContent(&$oss, $nestedObj, $depth, $bgcolor);
      outputTableContent(&$oss, $nestedObj, $depth, $alt);
      $depth--;
    }
  }
}

/*********************************************************
* Output XML info as HTML table, to be used for Display ,*
* not Saving                                             *
*********************************************************/

function printTableContent($obj, $depth, &$bgcolor)
{
  $caption = $obj->get_attribute("caption");
  $value = $obj->get_attribute("value");
  $description = $obj->get_attribute("description");
  $testOnly = $obj->get_attribute("testOnly");
  $techDetail = $obj->get_attribute("techDetail");
  $hexData = $obj->get_attribute("hexData");
  $tdClass = "";
  $colspan = 1;
  $fontColor = "";
  
  if ($testOnly == "1" || ($_SESSION["surveyLevel"] == "Summary" && ($techDetail == "1" || $hexData == "1")))
    return;   //Do not print out - do nada - skip the entire process

  if ($depth == 0) // if heading
  {
    if ($caption == "")
      $caption = TR("MSG_UNDEFINED");
    $bgcolor = "#968f89";
    $tdClass = "subhead";
    $colspan = 2;
    $fontColor = "white";
  }
  else if ($depth == 1) // if sub heading
  {
    if ($caption == "")
      $caption = TR("MSG_UNDEFINED");
    if ($bgcolor == "#ffffff" || $bgcolor == "#968f89") 
      $bgcolor = "#eeeeee";
    else
      $bgcolor =  "#ffffff";
    $fontColor = "black";
    $tdClass = "subhead";
  }
  else
  {
    if ($bgcolor == "#ffffff" || $bgcolor == "#968f89") 
      $bgcolor = "#eeeeee";
    else
      $bgcolor =  "#ffffff";
    $fontColor = "black";
    $tdClass = "normal";
    $colspan = 1;
  }

  // no matter what else, if it's hex data set it as follows:
  if ($obj->get_attribute("hexData") == "1")
  {
    $tdClass = "hexdata";    
    $colspan = 2;
  }

  $compareResult = $obj->get_attribute("compareResult");
  if ($compareResult != "" && $compareResult != "nestedChanges")
  {
    $fontColor = "#ff3333";
  }

  printf("  <tr>\n");
  printf("<td bgcolor='%s' class='%s' colspan=%d", $bgcolor, $tdClass, $colspan);
  printf(" nowrap><font color='%s'>\n", $fontColor);

  for ($i = 0; $i < $depth; $i++)
  {
    printf("&nbsp;&nbsp;&nbsp; ");
  }

  printf("%s", $caption);

  if ($colspan == 2)
  {
    //
    // Lets add the description as long as it has not been
    // updated once before
    //
    if ($value != "" || $description != "")
    {                                    
      if (!@strstr($caption, $description))
      {
        printf(" - ");
      }
      else
      {
        printf(" &nbsp; ");
      }
    }
  }
  else
  {
    printf(" </font></td><td bgcolor='%s'><font color='%s'> ", $bgcolor, $fontColor);
  }

  if ($value != "")
  {
    if ($value[0] == ' ')
    {
      $value = substr($value, 1);
      $value = "&nbsp; " . $value;
    }

    printf("%s", $value);
  }
  else if ($description != "")
  {
    if ($description[0] == ' ')
    {
      $description = substr($description, 1);
      $description = "&nbsp; " . $description;
    }

    //
    // Lets add the description as long as it has not been
    // updated once before
    //
    if (!strstr($caption, $description))
    {
      printf("%s", $description);
    }
  }
  else
  {
    printf("&nbsp; ");
  }

  printf(" </font></td></tr>\n");
  

  // Iterate through nested objects and call this function recursively.
  $nestedObjects = $obj->child_nodes();
  foreach ($nestedObjects as $nestedObj)
  {
    if (isset($nestedObj->tagname))
      $tagname = $nestedObj->tagname;
    else
      $tagname = "";
    if ($tagname == "device" || $tagname == "structure" || $tagname == "property")
    {
      $depth++;
      printTableContent($nestedObj, $depth, $bgcolor);
      $depth--;
    }
  }
}
/******************************************************************************
* Outout 2 xml objects side-by-side (Mainly Survey) to a formatted html table *
******************************************************************************/
function outputCompareContent(&$oss, $Lobj, $Robj, $depth, $changesOnly, &$alt)
{  
  $Lcaption = $Lobj->get_attribute('caption');
  $Lvalue = $Lobj->get_attribute('value');
  $Ldescription = $Lobj->get_attribute('description');

  $Rcaption = $Robj->get_attribute('caption');
  $Rvalue = $Robj->get_attribute('value');
  $Rdescription = $Robj->get_attribute('description');

  $testOnly = $Lobj->get_attribute('testOnly');
  $techDetail = $Lobj->get_attribute('techDetail');
  $hexData = $Lobj->get_attribute('hexData');
  $compareResult = $Robj->get_attribute('compareResult');
  
  if ($changesOnly == 'on' && $compareResult == '')
  {
    //do nothing - do not display it.
  }
  else
  {
    if ($depth == 0 || $hexData == '1' || ($Lvalue == '' && $Ldescription == ''))
      $colspan = '2';
    else
      $colspan = '1';

    if ($testOnly == '1' || ($_SESSION['surveyLevel'] == 'Summary' && ($techDetail == '1' || $hexData == '1')))
      return;   //Do not print out - do nada - skip the entire process

    if ($depth == 0) // heading
    {
      if ($Lcaption == '')
        $Lcaption = TR('MSG_UNDEFINED');
      $tag = 'th';
      $alt = false;
    }
    else if ($depth == 1) // if sub heading
    {
      if ($Lcaption == '')
        $Lcaption = TR('MSG_UNDEFINED');
      $tag = 'td';
      $alt = !($alt);
    }
    else
    {
      $tag = 'td';
      $alt = !($alt);
    }

    $class = '';
    if ($alt == true)
    {
      if ($compareResult != '' && $compareResult != 'nestedChanges')
        $class = 'class="alt change"';
      else
        $class = 'class="alt"';
    }
    else
    {
      if ($compareResult != '' && $compareResult != 'nestedChanges')
        $class = 'class="change"';
    }

    $span = '';
    if ($colspan == '2')
      $span = 'colspan="2"';

    $padding = '';
    if ($depth > 1)
      $padding = 'style="padding-left: '.(20 * ($depth - 1)).'px" ';


    $oss .= '<tr '.$class.'>'."\n";

    // LEFT OBJECT
    $oss .= '<'.$tag.' '.$span.$padding.' nowrap="nowrap">'.$Lcaption;
    if ($colspan == '2')
    {
      if ($Lvalue != '')
        $oss .= ' - '.$Lvalue;
      else if ($Ldescription != '' && $Ldescription != $Lcaption)
        $oss .= ' - '.$Ldescription;
      $oss .= '</'.$tag.'>'."\n";
    }
    else
    {
      $oss .= '</'.$tag.'>'."\n".'<'.$tag.'>';
      if ($Lvalue != '')
        $oss .= $Lvalue;
      else if ($Ldescription != '' && $Ldescription != $Lcaption)
        $oss .= $Ldescription;
      $oss .= '</'.$tag.'>'."\n";
    }

    // RIGHT OBJECT
    $oss .= '<'.$tag.' '.$span.$padding.' nowrap="nowrap">'.$Rcaption;
    if ($colspan == '2')
    {
      if ($Rvalue != '')
        $oss .= ' - '.$Rvalue;
      else if ($Rdescription != '' && $Rdescription != $Rcaption)
        $oss .= ' - '.$Rdescription;
      $oss .= '</'.$tag.'>'."\n";
    }
    else
    {
      $oss .= '</'.$tag.'>'."\n".'<'.$tag.'>';
      if ($Rvalue != '')
        $oss .= $Rvalue;
      else if ($Rdescription != '' && $Rdescription != $Rcaption)
        $oss .= $Rdescription;
      $oss .= '</'.$tag.'>'."\n";
    }

    $oss .= '</tr>'."\n";
  }
  // Iterate through nested objects and call this function recursively.
  $LobjChildren = $Lobj->child_nodes(); // we have to use child nodes for the count or we see weird results on some os'
  $LobjXpath = @xpath_new_context($Lobj);
  $LnestedObjects = @xpath_eval($LobjXpath, '/*');
  
  $RobjXpath = @xpath_new_context($Robj);
  $RnestedObjects = @xpath_eval($RobjXpath, '/*');

  for ($i=0; $i < count($LobjChildren); $i++)
  {
    $LnestedObj = $LnestedObjects->nodeset[$i];
    $RnestedObj = $RnestedObjects->nodeset[$i];
    $tagname = $LnestedObj->tagname;
    if ($tagname == 'device' || $tagname == 'structure' || $tagname == 'property')
    {
      $depth++;
      outputCompareContent($oss, $LnestedObj, $RnestedObj, $depth, $changesOnly, $alt);
      $depth--;
    }
  }
}

/******************************************************************************
* Outputs two XML Structure into a single HTML table. To be used for Display  *
* only                                                                        *
******************************************************************************/
function printCompareContent(&$numRows, $Lobj, $Robj, $depth, &$bgcolor, $changesOnly)
{  
  $caption = $Lobj->get_attribute("caption");
  $value = $Lobj->get_attribute("value");
  $description = $Lobj->get_attribute("description");
  $testOnly = $Lobj->get_attribute("testOnly");
  $techDetail = $Lobj->get_attribute("techDetail");
  $hexData = $Lobj->get_attribute("hexData");
  $tdClass = "";
  $colspan = 1;
  $fontColor = "";
  $compareResult = $Robj->get_attribute("compareResult");
  
  if ($changesOnly == "on" && $compareResult == "")
  {
    //do nothing - do not display it.
  }
  else
  {
    $numRows++;
    if ($testOnly == "1" || ($_SESSION["surveyLevel"] == "Summary" && ($techDetail == "1" || $hexData == "1")))
      return;   //Do not print out - do nada - skip the entire process

    if ($depth == 0) // if heading
    {
      if ($Lcaption == "")
        $Lcaption = TR("MSG_UNDEFINED");
      $bgcolor = "#968f89";
      $tdClass = "subhead";
      $colspan = 2;
      $fontColor = "white";
    }
    else if ($depth == 1) // if sub heading
    {
      if ($Lcaption == "")
        $Lcaption = TR("MSG_UNDEFINED");
      if ($bgcolor == "#ffffff" || $bgcolor == "#968f89") 
        $bgcolor = "#eeeeee";
      else
        $bgcolor =  "#ffffff";
      $fontColor = "black";
      $tdClass = "subhead";
    }
    else
    {
      if ($bgcolor == "#ffffff" || $bgcolor == "#968f89") 
        $bgcolor = "#eeeeee";
      else
        $bgcolor =  "#ffffff";
      $fontColor = "black";
      $tdClass = "normal";
      $colspan = 1;
    }

    // no matter what else, if it's hex data set it as follows:
    if ($Lobj->get_attribute("hexData") == "1")
    {
      $tdClass = "hexdata";    
      $colspan = 2;
    }


    $compareResult = $Robj->get_attribute("compareResult");
    if ($compareResult != "" && $compareResult != "nestedChanges")
    {
      $fontColor = "#ff3333";
    }

    printf("  <tr bgcolor='%s'>\n", $bgcolor);
    printf("<td width=25%% class='%s' colspan=%d><font color='%s'>\n", $tdClass, $colspan, $fontColor);

    if ($compareResult != "" && $compareResult != "nestedChanges")
      printf("<img src='change.jpg'>");

    for ($i = 0; $i < $depth; $i++)
    {
      printf("&nbsp;&nbsp;&nbsp; ");
    }

    printf("%s", $caption);

    if ($colspan == 2)
    {
      //
      // Lets add the description as long as it has not been
      // updated once before
      //
      if ($value != "" || $description != "")
      {                                    
        if (!@strstr($caption, $description))
        {
          printf(" - ");
        }
        else
        {
          printf(" &nbsp; ");
        }
      }
    }
    else
    {
      printf(" </font></td><td width=25%%><font color='%s'> ", $fontColor);
    }

    if ($value != "")
    {
      if ($value[0] == ' ')
      {
        $value = substr($value, 1);
        $value = "&nbsp; " . $value;
      }

      echo $value;
    }
    else if ($description != "")
    {
      if ($description[0] == ' ')
      {
        $description = substr($description, 1);
        $description = "&nbsp; " . $description;
      }

      //
      // Lets add the description as long as it has not been
      // updated once before
      //
      if (!strstr($caption, $description))
      {
        echo $description;
      }
    }
    else
    {
      echo "&nbsp; ";
    }

    echo " </font></td>\n";
  
  ////// RIGHT OBJECT  
    $caption = $Robj->get_attribute("caption");
    $value = $Robj->get_attribute("value");
    $description = $Robj->get_attribute("description");
    $testOnly = $Robj->get_attribute("testOnly");
    $techDetail = $Robj->get_attribute("techDetail");
    $hexData = $Robj->get_attribute("hexData");
  
    printf("<td width=25%% class='%s' colspan=%d", $tdClass, $colspan);
    printf("><font color='%s'>\n", $fontColor);

    for ($i = $headingDepth; $i < $depth; $i++)
    {
      printf("&nbsp;&nbsp;&nbsp; ");
    }

    printf("%s", $caption);

    if ($colspan == 2)
    {
      //
      // Lets add the description as long as it has not been
      // updated once before
      //
      if ($value != "" || $description != "")
      {                                    
        if (!@strstr($caption, $description))
        {
          echo " - ";
        }
        else
        {
          echo " &nbsp; ";
        }
      }
    }
    else
    {
      printf(" </font></td><td width=25%%><font color='%s'> ", $fontColor);
    }

    if ($value != "")
    {
      if ($value[0] == ' ')
      {
        $value = substr($value, 1);
        $value = "&nbsp; " . $value;
      }

      echo $value;
    }
    else if ($description != "")
    {
      if ($description[0] == ' ')
      {
        $description = substr($description, 1);
        $description = "&nbsp; " . $description;
      }

      //
      // Lets add the description as long as it has not been
      // updated once before
      //
      if (!strstr($caption, $description))
      {
        echo $description;
      }
    }
    else
    {
      echo "&nbsp; ";
    }

    echo " </font></td></tr>\n";

  }

  // Iterate through nested objects and call this function recursively.
  
  
  $LobjChildren = $Lobj->child_nodes(); // we have to use child nodes for the count or we see weird results on some os'
  $LobjXpath = @xpath_new_context($Lobj);
  $LnestedObjects = @xpath_eval($LobjXpath, "/*");
  
  $RobjXpath = @xpath_new_context($Robj);
  $RnestedObjects = @xpath_eval($RobjXpath, "/*");

  for ($i=0; $i < count($LobjChildren); $i++)
  {
    $LnestedObj = $LnestedObjects->nodeset[$i];
    $RnestedObj = $RnestedObjects->nodeset[$i];
    $tagname = $LnestedObj->tagname;
    if ($tagname == "device" || $tagname == "structure" || $tagname == "property")
    {
      $depth++;
      printCompareContent($numRows, $LnestedObj, $RnestedObj, $depth, $bgcolor,$changesOnly);
      $depth--;
    }
  }
}

function getDiagVersion()
{
  system($_SESSION["diagsDirectory"] ."hpdiags -diagversion 1>".$_SESSION["diagsDirectory"]."diagversion.txt");
  
  $ver = @file_get_contents($_SESSION["diagsDirectory"]."diagversion.txt");
  
  return substr($ver,13,6);
}

function IMLSupported()
{
  $inlString;
  $idXml = new DomDocument($_SESSION["idResult"]);
  $idXpath = xpath_new_context($idXml->document_element());
  $imlLog = @xpath_eval($idXpath, "/diagOutput/category[@name='miscellaneous']/structure[@name='imlLog']");
  if (count($imlLog->nodeset))
    $imlString = $imlLog->nodeset[0]->get_attribute("caption");
  if ($imlString == "" || strstr($imlString, "Not available"))
    return false;
  else
    return true;
}

function getDirectoryContents($path)
{
  if ($handle = @opendir($path))
  {
    $i=0;
    while (false !== ($file = @readdir($handle)))
    {
      if ($file != "." && $file != "..")
      {
        $contents[$i]=$file;
        $i++;
      }
    }
    closedir($handle);    
  }
  
  return $contents;
}

function IsUnitedLinux()
{
  if (file_exists("/etc/UnitedLinux-release"))
    return true;
  else
    return false;
}

function IsSLES9()
{
  if ($fh = @fopen("/etc/SuSE-release", "r"))
  {
    $buff = fgets($fh, 128);
    if (strstr($buff, "9"))
      return true;
    else
      return false;
  }
  else
    return false;
}

function getPathToFloppy()
{
  $ci = new client_info();
  $os = $ci->get_client_platform();
  if ($os == "Linux" || $os == "Unix")
  {
    if (IsUnitedLinux() || IsSLES9())
      return "/media/floppy/";
    else
      return "/mnt/floppy/";
  }
  else
    return "a:\\";
}
 

function isWinOS()
{
  $ci = new client_info();
  $os = $ci->get_client_platform();
  if ($os == "Linux" || $os == "Unix")
    return false;
  else
    return true;
}

/***********************************
* Return the appropriate supported *
* slash or backslash charachter    *
* depending on the OS              *
***********************************/
function SL()
{
  $ci = new client_info();
  $os = $ci->get_client_platform();
  if ($os == "Linux" || $os == "Unix")
    return "/";
  else
    return "\\";
}

function getIdResult()
{
  $idXml = new DomDocument($_SESSION["idResult"]);
  return xpath_new_context($idXml->document_element());
  return @xpath_eval($idXpath, "/diagOutput");
}

function getBuildVersion()
{
  $idXpath = getIdResult();
  $diagOutput = @xpath_eval($idXpath, "/diagOutput");
  if (count($diagOutput->nodeset))
    return $diagOutput->nodeset[0]->get_attribute("buildVersion");
  else
    return;
}

function getBuildDate()
{
  $idXpath = getIdResult();
  $diagOutput = @xpath_eval($idXpath, "/diagOutput");
  if (count($diagOutput->nodeset))
    return $diagOutput->nodeset[0]->get_attribute("buildDate");
  else
    return;
}

function getComputerName()
{
  $idXpath = getIdResult();
  $hostNameObj = @xpath_eval($idXpath, "/diagOutput/category[@name='miscellaneous']/structure[@name='systemSummary']/property[@name='hostName']");
  if (count($hostNameObj->nodeset))
    return $hostNameObj->nodeset[0]->get_attribute("value");
  else
    return;
}

function getSystemSerialNumber()
{
  $idXpath = getIdResult();              
  $serialNumberObj = @xpath_eval($idXpath, "/diagOutput/category[@name='assetControl']/structure[@name='productIdentification']/property[@name='serialNumber']");
  
  if (!count($serialNumberObj->nodeset))
     return;
  
  $digits = range(0, 9);
  $lowerCaseChars = range("a", "z");
  $upperCaseChars = range("A", "Z");
  $validDigitsAndChars = implode("",$digits) . implode("",$lowerCaseChars) . implode("",$upperCaseChars);
  $systemSerialNumber = $serialNumberObj->nodeset[0]->get_attribute("value");
  
  if(!$systemSerialNumber)
      return;

  $serialNumber = trim($systemSerialNumber);
  if(($count = strspn($serialNumber, $validDigitsAndChars)) == strlen($serialNumber))
     return $systemSerialNumber;
  else
     return;
}


function DriveExists($device)
{
  $idXpath = getIdResult();
  $devices = @xpath_eval($idXpath, "/diagOutput/category/device[@class='" . $device . "']");

  for ($d=0; $d < count($devices->nodeset); $d++)
  {
	if (strstr($devices->nodeset[$d]->get_attribute("name"), $device))
		return true;
  }

  return false;
}

/**************************************
* Checks to see if $device is mounted *
* ex. IsMounted("floppy")             *
**************************************/
function IsMounted($device)
{
  $ci = new client_info();
  $os = $ci->get_client_platform();
  
  if ($os == "Windows")
  {
     if($ci->IsWin2K() || file_exists("a:\\") || file_exists("A:\\"))
        return true;
     else
        return false;
  }
  else
  {
    $handle = @fopen("/proc/mounts", "r");
    
    if(!$handle)
       $handle = @fopen("/etc/fstab", "r");

    if ($handle)
    {
      while (!feof($handle))
      {
        $buffer = fgets($handle,4096);
      
        if (strstr($buffer,$device))
          return true;
      }
      fclose($handle);
    }
  }
  
  return false;
}

function SaveFile($filename, $target, $mount, $device, $filestring)
{
  $mount = str_replace('\\', '/', str_replace('\\\\', '/', $_REQUEST['mount']));
  if ($mount{strlen($mount)-1} != '/')
    $mount .= '/';
  if ($filename == '' || strstr($filename, '..') || strstr($filename, '/') || strstr($filename, '\\'))
  {
    return 'error:filename';
  }
  $unmountDirectory = true;
  $deleteDirectory = false;
  switch ($target)
  {
  case ('winfloppy'):
    $mount = 'a:\\\\';
  case ('winhardrive'):
    $unmountDirectory = false;
    $result = writeFile($filename, $filestring, $mount);
    if (stristr($result, 'error:'))
      return $result;
    else
      return 'success';
    break;
  case ('hardrive'):
    $unmountDirectory = false;
    $result = saveTempFile($filename, $filestring);
    if (stristr($result, 'error:'))
      return $result;
    else
      $tempFilename = $result;
    $result = copyFile($tempFilename, $filename, strlen($filestring), $mount, $device, $unmountDirectory, $deleteDirectory, false);
    if (stristr($result, 'error:'))
      return $result;
    else
      return 'success';
    break;
  case ('floppy'):
  case ('usbfloppy'):
  case ('diskonkey'):
    $result = mountDevice($device, $mount, $unmountDirectory, $deleteDirectory);
    if (stristr($result, 'error:'))
      return $result;
    $result = saveTempFile($filename, $filestring);
    if (stristr($result, 'error:'))
      return $result;
    else
      $tempFilename = $result;
    $result = copyFile($tempFilename, $filename, strlen($filestring), $mount, $device, $unmountDirectory, $deleteDirectory);
    if (stristr($result, 'error:'))
      return $result;
    if ($unmountDirectory == true)
      unmountDevice($mount, $deleteDirectory);
    return 'success';
    break;
  }
}

function mountDevice($device, $mount, &$unmountDirectory, &$deleteDirectory)
{
  // If mount point doesn't exist, create it and remember to delete it later
  if (!file_exists($mount))
  {
    $command = '<systemCall>mkdir '.$mount.'</systemCall>';
    ExecuteIOCommand($_SESSION['aipath'], $command, $stdout, $stderr);
    $response = extractTags($stdout, 'stdout', 'stderr');
    if ($response['stderr'] != '')
      return "error:mount:mkdir";
    $deleteDirectory = true;
  }
  // Make first mounting attempt, using exact device and mount arguments
  $command = '<systemCall>mount '.$device.' '.$mount.'</systemCall>';
  ExecuteIOCommand($_SESSION['aipath'], $command, $stdout, $stderr);
  $response = extractTags($stdout, 'stdout', 'stderr');
  // Check for errors
  if ($response['stderr'] != '')
  {
    if (!strstr($response['stderr'], 'must specify the filesystem') && !strstr($response['stderr'], 'already mounted'))
    {
      // If its not an error we can workaround, try to unmount the device and report the error
      unmountDevice($mount, $deleteDirectory);
      return getMountingError($response['stderr']);
    }
    else
    {
      $isAlreadyMounted = false;
      if (strstr($response['stderr'], 'already mounted') != false)
      {
        $matches = array();
        $pattern = "/mounted on ([^\s]+)/";
        $match = preg_match($pattern, $response['stderr'], $matches);
        if ($match > 0 && ($matches[1] == $mount || $matches[1].'/' == $mount))
        {
          $unmountDirectory = false;
          $isAlreadyMounted = true;
        }
      }
      if ($isAlreadyMounted == false)
      {
        // Try to mount again, specifying partition 1
        $command = '<systemCall>mount '.$device.'1 '.$mount.'</systemCall>';
        ExecuteIOCommand($_SESSION['aipath'], $command, $stdout, $stderr);
        $response = extractTags($stdout, 'stdout', 'stderr');
        // Check for errors
        if ($response['stderr'] != '')
        {
          // If its not an error we can workaround, try to unmount the device and report the error
          if (!strstr($response['stderr'], 'must specify the filesystem') && !strstr($response['stderr'], 'already mounted'))
          {
            unmountDevice($mount, $deleteDirectory);
            return getMountingError($response['stderr']);
          }
          else if (strstr($response['stderr'], 'already mounted'))
          {
            $matches = array();
            $pattern = "/mounted on ([^\s]+)/";
            $match = preg_match($pattern, $response['stderr'], $matches);
            if ($match <= 0 || ($matches[1] != $mount && $matches[1].'/' != $mount))
            {
              unmountDevice($mount, $deleteDirectory);
              return getMountingError($response['stderr']);
            }
            else
            {
              $unmountDirectory = false;
            }
          }
          else
          {
            // Try to mount again with original device argument, specify 'vfat' filesystem
            $command = '<systemCall>mount -t vfat '.$device.' '.$mount.'</systemCall>';
            ExecuteIOCommand($_SESSION['aipath'], '<systemCall>mount -t vfat '.$device.' '.$mount.'</systemCall>', $stdout, $stderr);
            $response = extractTags($stdout, 'stdout', 'stderr');
            // Check for errors
            if ($response['stderr'] != '')
            {
              // Give up and report this error
              unmountDevice($mount, $deleteDirectory);
              return getMountingError($response['stderr']);
            }
          }
        }
      }
    }
  }
  return 0;
}

function getMountingError($error)
{
  if (stristr($error, 'not a valid block device') || stristr($error, 'no medium found'))
    return 'error:mount:nomedia';
  else if (stristr($error, 'write-protected') || stristr($error, 'read-only'))
    return 'error:mount:readonly';
  else if (stristr($error, 'already mounted'))
    return 'error:mount:alreadymounted';
  else if (stristr($error, 'must specify the filesystem'))
    return 'error:mount:filesystem';
  else
    return 'error:mount:unknown';
} 

function unmountDevice($mount, &$deleteDirectory)
{
  chdir('/'); // Must move out of mount directory to unmount it
  $unmountSuccessful = false;
  for($i=0; $i<5 && $unmountSuccessful == false; $i++)
  {
    $command = '<systemCall>umount '.$mount.'</systemCall>';
    ExecuteIOCommand($_SESSION['aipath'], $command, $stdout, $stderr);
    $response = extractTags($stdout, 'stdout', 'stderr');
    if ($response['stderr'] == '')
    {
      $unmountSuccessful = true;
    }
    else
    {
      if (!strstr($response['stderr'], 'busy'))
      {
        $unmountSuccessful = true;
      }
      else
      {
        sleep(1);
      }
    }
  }
  if ($deleteDirectory == true)
  {
    $command = '<systemCall>rmdir '.$mount.'</systemCall>';
    ExecuteIOCommand($_SESSION['aipath'], $command, $stdout, $stderr);
    $response = extractTags($stdout, 'stdout', 'stderr');
  }
  return 0;
}

function writeFile($filename, $filestring, $mount)
{
  $filepath = $mount.$filename;
  $file = fopen($filepath, "w");
  $result = fwrite($file, $filestring);
  if (!$result)
    return 'error:write:fwrite';
  if (!file_exists($filepath))
    return 'error:write:exist';
  if ($result != strlen($filestring))
    return 'error:write:length';
  return 0;
}

function saveTempFile($filename, $filestring)
{
  $tempFilename = $filename.'.temp';
  $filepath = session_save_path().'/'.$tempFilename;
  $result = writeFile($tempFilename, $filestring, session_save_path().'/');
  if (stristr($result, 'error:'))
    return $result;
  else
    return $filepath;
}

function copyFile($tempFilepath, $filename, $filesize, $mount, $device, &$unmountDirectory, &$deleteDirectory, $doDoubleCheck=true)
{
  $command = '<systemCall>cp '.$tempFilepath.' '.$mount.$filename.'</systemCall>';
  ExecuteIOCommand($_SESSION['aipath'], $command, $stdout, $stderr);
  $response = extractTags($stdout, 'stdout', 'stderr');
  // If we have errors, unmount device, cleanup temp and report the error
  if ($response['stderr'] != '')
  {
    if ($unmountDirectory == true)
      unmountDevice($mount, $deleteDirectory);
    @unlink($tempFilepath);
    return 'error:copy:cp';
  }
  // If file doesn't exist after move, unmount device, cleanup temp and report the error
  chdir($mount);
  if (!file_exists($filename))
  {
    if ($unmountDirectory == true)
      unmountDevice($mount, $deleteDirectory);
    @unlink($tempFilepath);
    return 'error:copy:exist';
  }
  // If filesize doesn't match, unmount device, cleanup temp and report the error
  if (filesize($mount.$filename) != $filesize)
  {
    if ($unmountDirectory == true)
      unmountDevice($mount, $deleteDirectory);
    @unlink($tempFilepath);
    return 'error:copy:length';
  }
  @unlink($tempFilepath);
  // If we didn't have any problems up to now, double check by unmounting and remounting device
  if ($doDoubleCheck)
  {
    if ($unmountDirectory == true)
      unmountDevice($mount, $deleteDirectory);
    mountDevice($device, $mount, $unmountDirectory, $deleteDirectory);
    chdir($mount);
    if (!file_exists($filename))
    {
      if ($unmountDirectory == true)
        unmountDevice($mount, $deleteDirectory);
      return 'error:copy:exist:check';
    }
    if (filesize($mount.$filename) != $filesize)
    {
      if ($unmountDirectory == true)
        unmountDevice($mount, $deleteDirectory);
      return 'error:copy:length:check';
    }
  }
  return 0;
}


function extractTags()
{
  $arguments = func_get_args();
  $returnVal = array();
  $xmlString = $arguments[0];
  $xml = new DomDocument($xmlString);
  $xpath = xpath_new_context($xml->document_element());
  for ($i=1; $i<count($arguments); $i++)
  {
    $tagname = $arguments[$i];
    $elements = xpath_eval($xpath, '/'.$tagname);
    $tag = $elements->nodeset[0];
    if ($tag)
      $returnVal[$tagname] = $tag->get_content();
    else
      $returnVal[$tagname] = '';
  }
  return $returnVal;
}

function FactorySaveFile($filename, $location, $oss)
{
  if ($filename != "" && !strstr($filename, "..") && !strstr($filename, "/") && !strstr($filename, "\\"))
  {
    $length = strlen($oss);      
   
    $ci = new client_info();
    $os = $ci->get_client_platform();
    if ($location == "floppy")
    {    
      if ($os == "Linux" || $os == "Unix")
      {
        // mount floppy

  /////////////////////////
          if(IsOnline() && IsSLES9() && IsMounted("/dev/fd0"))
           {
              $fileP = "/media/floppy/";   
              $systemCallError = "";
              $returnString = "";
              $systemCallString = sprintf("<systemCall>ls -l %s</systemCall>", $fileP);
              ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $systemCallString, $returnString, $systemCallError);
              if (strstr($returnString, "No medium found"))
                   return 1;
          }
          else if (IsSLES9())
          {
            $fileP = "/media/floppy/";
          }
          else
          {
            $fileP = "/mnt/floppy/";
          }  
/////////////////////////////
       // $systemCallString = sprintf("<systemCall>mount %s</systemCall>", getPathToFloppy());
        $systemCallString = sprintf("<systemCall>mount %s</systemCall>", $fileP);
        ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $systemCallString, $returnString, $systemCallError);       
        if(strstr($returnString,"is write-protected"))
        {
            //$systemCallString = sprintf("<systemCall>umount %s</systemCall>", getPathToFloppy());
            $systemCallString = sprintf("<systemCall>umount %s</systemCall>", $fileP);
            ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $systemCallString, $returnString, $systemCallError);        
            return 2;
        }
        else if (strstr($returnString, "must specify")) // SOME FLOPPIES CANT HAVE FILESYSTEM AUTODETECTED, IN THIS CASE EXPLICITLY SPECIFY 'vfat'
        {
          $systemCallString = sprintf("<systemCall>mount -t vfat /dev/fd0 %s</systemCall>", $fileP);
          ExecuteIOCommand($_SESSION["diagsDirectory"]."hpdiagsai",$systemCallString, $returnString, $systemCallError);
          if(strstr($returnString,"is write-protected")) // CHECK AGAIN FOR IS WRITE-PROTECTED
          {
            $systemCallString = sprintf("<systemCall>umount %s</systemCall>", $fileP);
            ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $systemCallString, $returnString, $systemCallError);        
            return 2;
          }
        }
        $systemCallString = sprintf("<systemCall>ll | tee %s%s</systemCall>", $fileP,"bang");
        ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $systemCallString, $returnString, $systemCallError);   
        if(strstr($returnString, "No medium found"))
        {
          $systemCallString = sprintf("<systemCall>rm %s%s</systemCall>", $fileP,"bang");
          ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $systemCallString, $returnString, $systemCallError);           
          return 1;
        }
        
        if(strstr($returnString,"Read-only file system"))
        {
            $systemCallString = sprintf("<systemCall>rm %s%s</systemCall>", $fileP,"bang");
            ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $systemCallString, $returnString, $systemCallError);
            return 2;
        }
        if(strstr($returnString,"Input/output error"))
        {
            $systemCallString = sprintf("<systemCall>rm %s%s</systemCall>", $fileP,"bang");
            ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $systemCallString, $returnString, $systemCallError);        
            return 4;
        }
        $systemCallString = sprintf("<systemCall>rm %s%s</systemCall>", $fileP,"bang");
        ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $systemCallString, $returnString, $systemCallError);
        $file = session_save_path() . "tmp.html";  // for some reason we have to first save to a tmp file in Linux - maybe time issue
      }
      else
      {
        if (disk_free_space("a:\\") < $length)
          return 2; // disk too small
        $file = "a:\\" . $filename;
      }
    }
    else if ($location == "diskonkey")
    {
      if (!mountUSB("Transparent SCSI"))
        return 1; // failed to mount

      $systemCallString = sprintf("<systemCall>mount /mnt/diskonkey</systemCall>");
      ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $systemCallString, $returnString, $systemCallError);
      $file = session_save_path() . "tmp.html";
    }
    else if ($location == "usb") // usbdevice other than key (Floppy)
    {
      if (!mountUSB("Floppy"))
        return 1; // failed to mount usb floppy
      
      $file = session_save_path() . "tmp.html";
    }
    else
      $file = $_SESSION["diagsDirectory"] . $filename;
 
    // check to see if there is a floppy in the drive
    if ($location == "floppy" && (!IsMounted("floppy")) && ($os == "Linux" || $os == "Unix"))
    {
      return 1; // no floppy in drive
    }
    else if($fh = @fopen($file, "w"))
    {
      $res = fwrite($fh, $oss);
      fclose($fh);
      
      if ($os == "Linux" || $os == "Unix") 
      {         
        if ($location == "floppy")
        {
//          if (disk_free_space(getPathToFloppy()) < $length)
 //           return 2; // disk to small

//////////////////
            if(IsOnline() && IsSLES9() && IsMounted("/dev/fd0"))
               $fileP = "/media/floppy/";   
            else
               $fileP = "/mnt/floppy/";
      

            // mount the floppy
            $systemCallString = sprintf("<systemCall>mount %s</systemCall>", $fileP);
            ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $systemCallString, $returnString, $systemCallError);

            $file = session_save_path() . "tmp.html";  // for some reason we have to first save to a tmp file in Linux - maybe time issue

            //if (disk_free_space(getPathToFloppy()) < $length)
//            if (disk_free_space($fileP) < $length)
  //              return 4; // disk to small

//////////////////
          
          //$systemCallString = sprintf("<systemCall>cp %s %s%s</systemCall>", $file, getPathToFloppy(), $filename);
          $systemCallString = sprintf("<systemCall>cp %s %s%s</systemCall>", $file, $fileP, $filename);
          ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $systemCallString, $returnString, $systemCallError);
          $result = true;

          //$systemCallString = sprintf("<systemCall>umount %s</systemCall>", getPathToFloppy());
          $systemCallString = sprintf("<systemCall>umount %s</systemCall>", $fileP);
          ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $systemCallString, $returnString, $systemCallError);
        }
        else if ($location == "diskonkey")
        {
          if (disk_free_space("/mnt/diskonkey/") < $length)
            return 2; // disk to small

          $systemCallString = sprintf("<systemCall>cp %s /mnt/diskonkey/%s</systemCall>", $file, $filename);
          ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $systemCallString, $returnString, $systemCallError);
          
          
          $systemCallString = sprintf("<systemCall>umount /mnt/diskonkey</systemCall>");
          ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $systemCallString, $returnString, $systemCallError);
        }
        else if ($location == "usb")
        {
          if (disk_free_space("/mnt/usb/") < $length)
            return 2; // disk to small

          $systemCallString = sprintf("<systemCall>cp %s /mnt/usb/%s</systemCall>", $file, $filename);
          ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $systemCallString, $returnString, $systemCallError);
          
          $result = true;
         
          $systemCallString = sprintf("<systemCall>umount /mnt/usb</systemCall>");
          ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $systemCallString, $returnString, $systemCallError);
          
        }  
        else // must be hard drive
        {
          $systemCallString = sprintf("<systemCall>cp %s %s%s</systemCall>", $file,$_SESSION["diagsDirectory"],$filename);
          ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $systemCallString, $returnString, $systemCallError);        
        }
        


        if (strstr($returnString, "No") || strstr($returnString, "Read-only")) // device full
        {
          return 2;  // failed
        }

      }
      else if ($length != $res)
      {
        return 2; // disk full - Windows
      }
      
      return 0;  //passed - whew!
    }
    else
    {  // Error Opening File
      return 3;
    }
  }
  else
  { // found invalid file name
    return 4;
  }
}

function mountUSB($device)
{
  $ci = new client_info();
  $os = $ci->get_client_platform();
  if ($os == "Linux" || $os == "Unix")
  {
    $scsiHost = "";
    $devsg = "";
    $devsd = "";
    $foundIt = false;

    for ($i=0; $i < 10; $i++)
    {
      for ($j=0; $j < 7; $j++)
      {
        if (file_exists("/proc/scsi/usb-storage/"))
        {
          $usbProcPath = "/proc/scsi/usb-storage/" . $i;
        }
        else
          $usbProcPath = "/proc/scsi/usb-storage-" . $i ."/" . $j;
        $handle = @fopen($usbProcPath, "r");
        if ($handle)
        {
          while (!feof($handle)) 
          {
            $buffer = fgets($handle, 4096);
			if (strstr($buffer, "Multi")) // its a multibay usb device
			  break;
            if (strstr($buffer, "Host"))
            {
              $scsiHost = substr($buffer,8,5);
            }
            if (strstr($buffer,$device))
            {
              $foundIt = true;
              //break out of for loop
              $j = 8;
              $i = 11;
              break; // we found the USB device
            }
          }
          if ($foundIt)
            break;
        }
        if ($foundIt)
         break;
      }
      @fclose($handle);
    }

    ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", "<systemCall>/opt/hp/hpdiags/sg_scan</systemCall>", $resultString, $compareError);

    if ($resultString && $foundIt)
    {
      if (@strstr($resultString, $scsiHost))
      {      
        $pieces = explode("&#10;", $resultString);
        $size = count($pieces);

        for ($i=0; $i < $size; $i++)
        {
          if (strstr($pieces[$i], $scsiHost))
          {
            $piece = strstr($pieces[$i], "/dev"); // make sure that we have the /dev/XXX
            $devsg = substr($piece, 0, strpos($piece, ":"));
          }
        }
      }
      else
        return false;
    }

    ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", "<systemCall>/opt/hp/hpdiags/sg_map</systemCall>", $resultString, $compareError);

    if ($resultString)
    {
      if (@strstr($resultString, $devsg))
      {
         $pieces = explode("  ",$resultString);
         $size = count($pieces);

         for ($i=0; $i < $size; $i++)
         {
           if (strstr($pieces[$i],$devsg))
             $devsd = substr($pieces[$i+1], 0, 8); // 8 represents /dev/sxx - tried using strpos but didnt work
         }
      }
      else
        return false;
    }

    if ($devsd == "")
      return false;

    if ($device == "Transparent SCSI") //if it's a usb key we have to have a different moint point
      $mountPoint = "diskonkey";
    else
      $mountPoint = "usb"; // if usb floppy

    ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", "<systemCall>mkdir /mnt/".$mountPoint."</systemCall>", $resultString, $compareError);

    $mountCmd = sprintf("<systemCall>mount %s /mnt/%s</systemCall>", $devsd, $mountPoint);
    ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $mountCmd, $resultString, $compareError);

    if (strstr($resultString, "can't find") || strstr($resultString, "is not a valid") || strstr($resultString, "No medium found"))
      return false;
    else if (strstr($resultString, "you must specify") || strstr($resultString, "already mounted"))
    {  // sometimes we need to attach a 1 to the end of the device for it to work
      $mountCmd = sprintf("<systemCall>mount %s1 /mnt/%s</systemCall>", $devsd, $mountPoint);
      ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $mountCmd, $resultString, $compareError);
      if (strstr($resultString, "can't find") || strstr($resultString, "is not a valid"))
          if (strstr($resultString, "can't find") || strstr($resultString, "is not a valid") || strstr($resultString, "No medium found"))
        return false;
      else
        return true;
    }
    else
      return true;
  }
}

/*****************************************
* This function checks that a usb device *
* is attached by first looking through   *
* the /proc/scsi/usb-storage file        *
*                                        *
* Linux only                             *
*****************************************/
function checkForUSBDevice($device)
{
  $foundIt = false;
  $foundItAttached = false;
  $attached = false;
  $isUSBDeviceAttached = false;
  $ci = new client_info();
  $os = $ci->get_client_platform();
  if ($os == "Linux" || $os == "Unix")
  {
    $scsiHost = "";
    $devsg = "";
    $devsd = "";

    //check if any usb device attached
    for ($i=0; $i < 10; $i++)
    {
      for ($j=0; $j < 7; $j++)
      {
        if (file_exists("/proc/scsi/usb-storage/"))
        {
          $usbProcPath = "/proc/scsi/usb-storage/" . $i;
          $j = 6;
        }
        else
          $usbProcPath = "/proc/scsi/usb-storage-" . $i ."/" . $j;
          
        // try to open file name 0 to 9
        $handle = @fopen($usbProcPath, "r");
        if ($handle)
        {
          while (!feof($handle)) 
          {
            $buffer = fgets($handle, 4096);

            if (strstr($buffer, "Multi")) // if multibay device
			  break;

            if (strstr($buffer, "Host"))
            {
              $scsiHost = substr($buffer,8,5);
            }
            
            if (strstr($buffer,$device))
              $foundIt = true;
            
            if ($foundIt && strstr($buffer, "Attached:"))
            {
              $attached = true;
              if (strstr($buffer, "Yes"))
                $foundItAttached = true;                            
            }
          }
          if ($attached)
            break;
        }

        if ($attached)
         break;
      }
      @fclose($handle);
      if ($foundIt)
        break;
    }
  } // end of if linux or unix
  
  //if we found it but it did not have the Attached entry at all
  if ($foundIt && !$attached)
    $foundItAttached = true;
    
  return $foundItAttached;
}

/******************
* Encode xml node *
******************/
function my_dump_node($node,$encoding)
{
   $domNode = domxml_new_doc("1.0");
   $clonedNode = $node->clone_node(true);
   $domNode->append_child($clonedNode);
   $result = $domNode->dump_mem(true,$encoding);
   $pos = strpos($result,"?>");
   return substr($result,$pos+2);
}

/*********************************************
* Convert AI time format HH:MM:SS to minutes *
*********************************************/
function ConvertAITimeToMinutes($AItime)
{
  $pieces = explode(":",$AItime);
  $hours = $pieces[0];
  $minutes = $pieces[1];
  $seconds = $pieces[2];
  return ($hours * 60) + ($seconds * .01) + $minutes;
}


function CreateSaveDiv($defaultFilename)
{
  echo '<div id="rootIt" style="left: 100px; top: 70px; height: auto; visibility: hidden; display: none;" name="rooty">'."\n";
  echo '<div id="handleIt" width="100%" style="font-weight: bold;">'.TR('MSG_SAVE').'</div>'."\n";
  echo '<div id="scrollContainerIt" style="padding: 5px">'."\n";
  echo '<span id="saveBoxMessage">'.TR("MSG_NO_MEDIA_DEVICES_DETECTED_RESCAN").'</span>'."\n";
  echo '<div id="saveBoxChoices"></div>'."\n";
  echo '<table id="saveBoxControls">'."\n".'<tr>'."\n";
  echo '<td>'.TR('MSG_FILENAME').': <input type="text" id="saveBoxFilename" value="'.$defaultFilename.'" onKeyPress="getEnterPress(event)"></td>'."\n";
  echo '<td>'.MakeButton(TR('MSG_SAVE'), 'saveFile(\'2\');', 'saveButton').'</td>'."\n";
  echo '<td>'.MakeButton(TR('MSG_CANCEL'), 'document.getElementById(\'rootIt\').style.display = \'none\'; document.getElementById(\'rootIt\').style.visibility = \'hidden\';','').'</td>'."\n";
  echo '</tr>'."\n".'</table>'."\n";
  echo '<div id="rescanButton">'.MakeButton(TR('MSG_RESCAN_DEVICES'), 'scanForSaveDevices();', '').'</div>'."\n";
  echo '<div id="cancelButton">'.MakeButton(TR('MSG_CANCEL'), 'document.getElementById(\'rootIt\').style.display = \'none\'; document.getElementById(\'rootIt\').style.visibility = \'hidden\';', '').'</div>'."\n";
  echo '<div id="scrollContentIt"></div>'."\n";
  echo '</div>'."\n".'</div>'."\n";
}

function Save_CheckIfFileExits($location, $filename, $formName)
{
  $ci = new client_info();
  $os = $ci->get_client_platform();
  
  printf("<script language=Javascript>\n");

  if ($location == "floppy")
  {
    //if ($os == "Linux" || $os == "Unix")
      //ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", "<systemCall>mount " . getPathToFloppy() . "</systemCall>", $returnString, $systemCallError);
    //$fileP = getPathToFloppy() . $filename;

     if(isWinOS())
     {
         $fileP = "a:\\".$filename;
     }
     else
     {
        if(IsOnline() && IsSLES9())
        {
        //     printf("alert('SLES9');");
            $fileP = "/media/floppy/" . $filename;
        }
        else
        {
        //   printf("alert('NOT SLES9');");
            $fileP = "/mnt/floppy/" . $filename;
        }
     }
  }
  else if ($location == "diskonkey")
  {  
    mountUSB("Transparent SCSI");
    $fileP = "/mnt/diskonkey/" . $filename;
  }
  else if ($location == "usb")
  {
    //printf("alert('usb');");
    mountUSB("Floppy");
    $fileP = "/mnt/usb/" . $filename;
  }
  else
    $fileP = $_SESSION["diagsDirectory"] . $filename;

  
  if (file_exists($fileP))
  {
    printf("if  (!window.confirm(\"%s\"))\n{", TR("MSG_OVERWRITE_FILE_YES_NO"));
    printf("    \n  document.%s.save.value=0;\n", $formName);
    printf("    document.%s.submit();\n   }\n", $formName);
    printf("else\n");
    printf("{\n");
    printf("  document.%s.saveLocation.value='%s';\n", $formName, $location);
    printf("  document.%s.filename.value='%s';\n", $formName, $filename);
  //  printf("alert('overwritten file');");
    printf("  saveFile(3);\n}\n");
  }
  else
  {
    printf("  document.%s.saveLocation.value='%s';\n", $formName, $location);
    printf("  document.%s.filename.value='%s';\n", $formName, $filename);
    //printf("alert('save file');");
    printf("  saveFile(3);\n");
  }
  printf("</script>\n");  
}

function Save_CheckIfFileExists($target, $device, $mount, $filename, $formName)
{
  $unmountDirectory = true;
  $deleteDirectory = false;
  $mountResult = mountDevice($device, $mount, $unmountDirectory, $deleteDirectory);
  if ($mountResult != 0)
    Save_Complete($mountResult);
  chdir($mount);
  if (file_exists($filename))
  {
    $overwriteMsg = TR("MSG_OVERWRITE_FILE_YES_NO");
    echo <<<JavaScript
      <script type="text/javascript">
      if (!window.confirm('$overwriteMsg'))
      {
        document.$formName.save.value = 0;
        document.$formName.submit();
      }
      else
      {
        document.$formName.save.value = 3;
        document.$formName.target.value = '$target';
        document.$formName.filename.value = '$filename';
        document.$formName.device.value = '$device';
        document.$formName.mount.value = '$mount';
        document.$formName.submit();
        //saveFile(3)
      }
      </script>
JavaScript;
  }
  else
  {
    echo <<<JavaScript
      <script type="text/javascript">
      document.$formName.save.value = 3;
      document.$formName.target.value = '$target';
      document.$formName.filename.value = '$filename';
      document.$formName.device.value = '$device';
      document.$formName.mount.value = '$mount';
      document.$formName.submit();
      //saveFile(3)
      </script>;
JavaScript;
  }
  if ($unmountDirectory == true)
    unmountDevice($mount, $deleteDirectory);
  return 0;
}

function Save_Complete($result)
{
  if (is_numeric($result))
  {
    if ($result == 1 || $result == 3)
      echo '<script type="text/javascript">'."\n".'alert("'.TR('MSG_WRITEERROR').' - '.TR('MSG_PLEASE_CHECK_MEDIA').'");'."\n".'</script>'."\n";
    else if ($result == 2)
      echo '<script type="text/javascript">'."\n".'alert("'.TR('MSG_WRITEERROR').' - '.TR('MSG_DISK_FULL').'");'."\n".'</script>'."\n";
    else if ($result == 4)
      echo '<script type="text/javascript">'."\n".'alert("'.TR('MSG_WRITEERROR').' - '.TR('MSG_BAD_FORMAT').'");'."\n".'</script>'."\n";
    else
      echo '<script type="text/javascript">'."\n".'alert("'.TR('MSG_FILE_WRITE_COMPLETE').'");'."\n".'</script>'."\n";
  }
  else
  {
    $resultBits = explode(':', $result);
    if ($resultBits[0] == 'success')
    {
      echo '<script type="text/javascript">'."\n".'alert("'.TR('MSG_FILE_WRITE_COMPLETE').'");'."\n".'</script>'."\n";
    }
    else if ($resultBits[0] == 'error')
    {
      switch ($resultBits[1])
      {
      case ('filename'):
        echo '<script type="text/javascript">'."\n".'alert("'.TR('MSG_BAD_FORMAT').' (101)");'."\n".'</script>'."\n";
        break;
      case ('mount'):
        switch ($resultBits[2])
        {
        case ('nomedia'):
          echo '<script type="text/javascript">'."\n".'alert("'.TR('MSG_WRITEERROR').' - '.TR('MSG_INSERT_FLOPPY_SAVE').' (201)");'."\n".'</script>'."\n";
          break;
        case ('readonly'):
          echo '<script type="text/javascript">'."\n".'alert("'.TR('MSG_WRITEERROR').' - '.TR('MSG_READ_ONLY_DISK').' (202)");'."\n".'</script>'."\n";
          break;
        case ('filesystem'):
          echo '<script type="text/javascript">'."\n".'alert("'.TR('MSG_WRITEERROR').' - '.TR('MSG_UNSUPPORTED_FILESYSTEM').' (203)");'."\n".'</script>'."\n";
          break;
        default:
          $errorcode = '';
          if ($resultBits[2] == 'alreadymounted')
            $errorcode = '204';
          if ($resultBits[2] == 'mkdir')
            $errorcode = '211';
          if ($resultBits[2] == 'unknown')
            $errorcode = '200';
          echo '<script type="text/javascript">'."\n".'alert("'.TR('MSG_WRITEERROR').' ('.$errorcode.')");'."\n".'</script>'."\n";
        }
        break;
      case ('write'):
        $errorcode = '';
        if ($resultBits[2] == 'fwrite')
          $errorcode = '301';
        if ($resultBits[2] == 'exist')
          $errorcode = '302';
        if ($resultBits[2] == 'length')
          $errorcode = '303';
        echo '<script type="text/javascript">'."\n".'alert("'.TR('MSG_WRITEERROR').' - '.TR('MSG_PLEASE_CHECK_MEDIA').' ('.$errorcode.')");'."\n".'</script>'."\n";
        break;
      case ('copy'):
        $errorcode = '';
        if ($resultBits[2] == 'cp')
          $errorcode = '401';
        if ($resultBits[2] == 'exist')
        {
          if (isset($resultBits[2]) && $resultBits[2] == 'check')
            $errorcode = '422';
          else
            $errorcode = '412';
        }
        if ($resultBits[2] == 'length')
        {
          if (isset($resultBits[2]) && $resultBits[2] == 'check')
            $errorcode = '423';
          else
            $errorcode = '413';
        }
        echo '<script type="text/javascript">'."\n".'alert("'.TR('MSG_WRITEERROR').' - '.TR('MSG_PLEASE_CHECK_MEDIA').' ('.$errorcode.')");'."\n".'</script>'."\n";
        break;
      default:
        echo '<script type="text/javascript">'."\n".'alert("'.TR('MSG_WRITEERROR').' ('.$result.')");'."\n".'</script>'."\n";
      }
    }
    else
    {
      echo '<script type="text/javascript">'."\n".'alert("'.TR('MSG_WRITEERROR').' ('.$result.')");'."\n".'</script>'."\n";
    }
  }
}

function SaveFileScript($formName)
{
  $pleaseEnterFilenameMsg = TR("MSG_PLEASE_ENTER_FILENAME");
  $pleaseSelectSaveLocation = TR("MSG_PLEASE_SELECT_SAVE_LOCATION");
  echo <<<JavaScript
    <script type="text/javascript">
    function saveFile(s)
    {
      var filename = document.getElementById('saveBoxFilename').value;
      if (s == 2 && (filename == '' || filename == '.html' || filename == '.htm'))
      {
        alert('$pleaseEnterFilenameMsg');
        return;
      }
      var selectedTarget = '';
      var choices = document.getElementById('saveBoxChoices').getElementsByTagName('input');
      for (var i=0; i<choices.length; i++)
      {
        if (choices[i].checked == true)
          selectedTarget = choices[i].value;
      }
      if (s == 2 && selectedTarget == '')
      {
        alert('$pleaseSelectSaveLocation');
        return;
      }
      if (s == 2)
      {
        var selectedTargetBits = selectedTarget.split("__");
        document.$formName.target.value = selectedTargetBits[0];
        document.$formName.device.value = selectedTargetBits[1];
        document.$formName.mount.value = selectedTargetBits[2];
        document.$formName.filename.value = filename;
        document.$formName.save.value = s;
      }
      document.$formName.submit();
    }
    </script>
JavaScript;
}

function BuildSaveDivJavascript($formName)
{
  $scanningMessage = TR("MSG_SCANNING_FOR_DEVICES");
  $selectLocationMessage = TR("MSG_PLEASE_SELECT_SAVE_LOCATION");
  $noDevicesFoundMessage = TR("MSG_NO_MEDIA_DEVICES_DETECTED_RESCAN");
  $hardriveLabel = TR("MSG_SAVE_TO_HARDRIVE");
  $floppyLabel = TR("MSG_SAVE_TO_FLOPPY");
  $usbfloppyLabel = TR("MSG_SAVE_TO_USB_FLOPPY");
  $usbkeyLabel = TR("MSG_SAVE_TO_USB_KEY");
  echo <<<JavaScript
  function DisplaySaveDiv()
  {
    scanForSaveDevices();
    document.getElementById('rootIt').style.display = 'inline';
    document.getElementById('rootIt').style.visibility = 'visible';
    //document.$formName.filename.focus();
  }
  
  function getEnterPress(e)
  {
    var keycode;
    if (window.event)
      keycode = window.event.keyCode;
    else if (e)
      keycode = e.which;
    else
      return true;
    if (keycode == 13)
      saveFile('2');
  }

  function scanForSaveDevices()
  {
    document.getElementById('saveBoxMessage').innerHTML = "$scanningMessage";
    document.getElementById('saveBoxChoices').innerHTML = "";
    document.getElementById('saveBoxControls').style.display = 'none';
    document.getElementById('rescanButton').style.display = 'none';
    document.getElementById('cancelButton').style.display = '';
    var request = new RemoteProcedureCall('devicedetection.php');
    request.callback = updateSaveDevices;
    request.send();
  }

  function updateSaveDevices(deviceString)
  {
    var hardriveLabel = "$hardriveLabel";
    var floppyLabel = "$floppyLabel";
    var usbfloppyLabel = "$usbfloppyLabel";
    var usbkeyLabel = "$usbkeyLabel";
    var devices = eval(deviceString);
    if (devices.length > 0)
    {
      document.getElementById('cancelButton').style.display = 'none';
      document.getElementById('saveBoxMessage').innerHTML = "$selectLocationMessage";
      var choiceBox = document.getElementById('saveBoxChoices');
      choiceBox.innerHTML = '';
      for (var i=0; i<devices.length; i++)
      {
        var device = devices[i];
        if (device != null && device != undefined && device != '')
        {
          var text = '';
          switch (device.label)
          {
          case 'hardrive':
            text = "$hardriveLabel";
            break;
          case 'floppy':
            text = "$floppyLabel";
            break;
          case 'usb_key':
            text = "$usbkeyLabel";
            break;
          case 'usb_floppy':
            text = "$usbfloppyLabel";
            break;
          default:
            text = device.label;
          }
          if (device.suffix != '')
            text += " ("+device.suffix+")";
          value = device.target+"__"+device.device+"__"+device.mount;
          var choice = '<label><input type="radio" name="saveBoxChoice" value="'+value+'">'+text+'</label><br>';
          choiceBox.innerHTML += choice;
        }
      }
      document.getElementById('saveBoxControls').style.display = '';
    }
    else
    {
      document.getElementById('cancelButton').style.display = '';
      document.getElementById('saveBoxMessage').innerHTML = "$noDevicesFoundMessage";
      document.getElementById('saveBoxControls').style.display = 'none';
    }
    document.getElementById('rescanButton').style.display = '';
  }
JavaScript;
}

function CreateAboutDiv()
{
  $idXml = new DomDocument($_SESSION["idResult"]);
  $idXpath = @xpath_new_context($idXml->document_element());
  
  printf("<div id='aboutrootIt' style='left:220px; top:50px; Visibility:hidden; display:none;' name='aboutrootIt'>");
  printf("  <div id='abouthandleIt' width=100%%><b>%s</b></div>", TR("MSG_ABOUT"));
  printf("     <div id='aboutscrollContainerIt'>");

  printf("<table cellpadding=0 height='100' width='100'>");
  printf( "<tr>    <td bgcolor=#003366 height=50 border=0><img src='about_splash.gif'>    </td>  </tr>");
  printf("  <tr>    <td bgcolor=#003366 >");
  printf("      <table width=100%%>        <tr>          <td>            <img src='hp_logo_invent.png'>          </td>        </tr>");
  printf("      <tr>          <td align='right'>            <img src='prodnameheading.GIF' border='0' hspace='0'>            <font style='color:white;font-size:12px;font-weight: bold;' >");
  // is the OS 64 bit?        
  $ci = new client_info();
  if (strstr($ci->get_client_platform(), "indows"))
    $x64 = @xpath_eval($idXpath,"/diagOutput/category[@name='operatingSystem']/structure[@name='osVendorVersion']/property[@name='osSystemInfo']");
  else             
    $x64 = @xpath_eval($idXpath,"/diagOutput/category[@name='operatingSystem']/structure[@name='operatingSystem']/property[@name='osCommercialName']");
                
  if (count($x64->nodeset))
  { // display that we are in 64 bit OS
    if (strstr($x64->nodeset[0]->get_attribute("value"), "64"))
      printf("x64");
  }

  printf("<br>");
  // get and display the build version
  $diagOutput = @xpath_eval($idXpath, "/diagOutput");
  if (count($diagOutput->nodeset))
    printf("%s %s&nbsp;&nbsp;%s&nbsp;", TR("MSG_VERSION"), $diagOutput->nodeset[0]->get_attribute("buildVersion"),$diagOutput->nodeset[0]->get_attribute("buildDate")) ;              
  
  printf("          </td>        </tr>");
  printf("        <tr>          <td align='right' height='70' valign='bottom'>");
  printf("            <font style='color:white;font-size:12px;font-weight: bold;' >%s &copy; 2002 - 2007 Hewlett-Packard Development Company, L.P.&nbsp;&nbsp;", TR("MSG_COPYRIGHT"));
  printf("        </td>        </tr>      </table>    </td>  </tr>");
  printf("  <tr bgcolor=#003366 >    <td align='center'>");
  printf("%s", MakeButton(TR("MSG_OK"),"document.getElementById('aboutrootIt').style.visibility='hidden';document.getElementById('aboutrootIt').style.display='none';"));
  printf("  </td>  </tr></table><div id='aboutscrollContentIt'></div></div></div>");

}

function findElementWithRomTest($tests,$num_tests, &$elementWithRomTest)
{
    for ($k=0; $k < $num_tests; $k++)
    {
      $testNode = $tests->nodeset[$k];
      $package = "0";
      $package = $testNode->get_attribute("package");
      if ($package == "1")
        continue;
      $testName = $testNode->get_attribute("name");
    
      if($testName == "membistTest")
      {
         $elementWithRomTest = $k;
         break;
      }
    
    }
}

function start_session()
{
  if (!isOnline())
  {
    // if we are in the offline environment, override session garbage collection
    ini_set('session.gc_probability','0');
    ini_set('session.gc_divisor','0');
  }
  session_start();
  if (!isset($_SESSION['diagsDirectory']) && isOnline())
  {
    // if we are online and the session variables are missing, re-initialize
    $ci = new client_info();
    $os = $ci->get_client_platform();
    if ($os == "Windows")
      $_SESSION["diagsDirectory"] = "\\hp\\hpdiags\\";
    else
      $_SESSION["diagsDirectory"] = "/opt/hp/hpdiags/";
  
    $_SESSION["testpid"] = "";
    $_SESSION["diagRun"] = "";
    $_SESSION["statusxml"] = "";
    $_SESSION["currentCategory"] = "overview";
    $_SESSION["testMode"] = "unattended";
    $_SESSION["surveyLevel"] = "Summary";
    $_SESSION["surveyTimeStamp"] = "";
    // loadTransArray inserts translation array into session
    loadTransArray(GetLanguage());
    // We use idResult.xml to repopulate the idResult variable rather than running ID again
    if (file_exists($_SESSION['diagsDirectory']."idResult.xml"))
    {
      $_SESSION["idResult"] = "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n".file_get_contents($_SESSION['diagsDirectory']."idResult.xml");
      $_SESSION["surveyTimeStamp"] = preg_replace("/.*timeStamp=\"([0-9]+)\".*/","$1",str_replace("\n",'',$_SESSION["idResult"]));
    }
    $_SESSION["testPage"] = "";
    $_SESSION["promptID"] = "";
    $_SESSION["statusDrawn"] = "false";
    $_SESSION["prompting"] = FALSE;
    $_SESSION["REFRESH_RATE"] = 2;
  }
}

function debug($logstring)
{
  $file = fopen(session_save_path().'/debugLog.txt', 'a');
  fwrite($file, date('H:i:s').' - '.$logstring."\n");
  fclose($file);
}

?>